package jalview.datamodel;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: Dundee University</p>
 *
 * @author not attributable
 * @version 1.0
 */
public class AlignmentView
{
    /**
     * Transient object compactly representing a 'view' of an alignment - with discontinuities marked.
     */
    private SeqCigar[] sequences = null;
  private int[] contigs = null;
  private int width=0;
  public AlignmentView(CigarArray seqcigararray)
  {
    if (!seqcigararray.isSeqCigarArray())
      throw new Error("Implementation Error - can only make an alignment view from a CigarArray of sequences.");
    //contigs = seqcigararray.applyDeletions();
    contigs = seqcigararray.getDeletedRegions();
    sequences = seqcigararray.getSeqCigarArray();
    width = seqcigararray.getWidth(); // visible width
  }

  public void setSequences(SeqCigar[] sequences)
  {
    this.sequences = sequences;
  }

  public void setContigs(int[] contigs)
  {
    this.contigs = contigs;
  }

  public SeqCigar[] getSequences()
  {
    return sequences;
  }

  public int[] getContigs()
  {
    return contigs;
  }
  public Object[] getAlignmentAndColumnSelection(char gapCharacter) {
    ColumnSelection colsel = new ColumnSelection();

    return new Object[] { SeqCigar.createAlignmentSequences(sequences, gapCharacter, colsel, contigs), colsel};
  }
  /**
   * getSequenceStrings
   *
   * @param c char
   * @return String[]
   */
  public String[] getSequenceStrings(char c)
  {
    String[] seqs=new String[sequences.length];
    for (int n=0; n<sequences.length; n++) {
      seqs[n] = sequences[n].getSequenceString(c);
    }
    return seqs;
  }
  /**
   * 
   * @return visible number of columns in alignment view
   */
  public int getWidth() {
    return width;
  }

  protected void setWidth(int width) {
    this.width = width;
  }
  
}
